## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
##
## by GIR
##

from CvPythonExtensions import *
import CvUtil
import PyHelpers
import Popup as PyPopup

# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo

########################################################################################################################################
				
class adPerks:						
	def onCombatResult(self, argsList):

		heroUnit = argsList[0]

	### def spec unit upgrade ###
		u_mArmor = gc.getInfoTypeForString("UNIT_MODERN_ARMOR")
		u_mArmorD = gc.getInfoTypeForString("UNIT_MODERN_ARMOR_DESERT")
		u_mArmorS = gc.getInfoTypeForString("UNIT_MODERN_ARMOR_SNOW")
		u_Arty = gc.getInfoTypeForString("UNIT_ARTILLERY")
		unitfilter = [ u_mArmor, u_mArmorD, u_mArmorS, u_Arty ]

		p_freeup = gc.getInfoTypeForString("PROMOTION_FREEUPGRADE")

	### def berserker / stalwart perks ###
		p_atk2 = gc.getInfoTypeForString("PROMOTION_ATTACK2")
		p_df2 = gc.getInfoTypeForString("PROMOTION_DEFENCE2")

	### def specialist Promotion (begin) ###
		p_combat5 = gc.getInfoTypeForString("PROMOTION_COMBAT5")
		p_drill4 = gc.getInfoTypeForString("PROMOTION_DRILL4")
		p_flanking2 = gc.getInfoTypeForString("PROMOTION_FLANKING2")
		p_cg3 = gc.getInfoTypeForString("PROMOTION_CITY_GARRISON3")
		p_craider3 = gc.getInfoTypeForString("PROMOTION_CITY_RAIDER3")
		p_guerilla2 = gc.getInfoTypeForString("PROMOTION_GUERILLA2")
		p_woodsman2 = gc.getInfoTypeForString("PROMOTION_WOODSMAN2")
		p_desertc1 = gc.getInfoTypeForString("PROMOTION_WARMTH1")
		p_arcticc1 = gc.getInfoTypeForString("PROMOTION_COLD1")
		p_pinch2 = gc.getInfoTypeForString("PROMOTION_PINCH2")
		p_charge2 = gc.getInfoTypeForString("PROMOTION_CHARGE2")
		p_ambush2 = gc.getInfoTypeForString("PROMOTION_AMBUSH2")
		p_ambush3 = gc.getInfoTypeForString("PROMOTION_AMBUSH3")
		p_cover2 = gc.getInfoTypeForString("PROMOTION_COVER2")
		p_shock2 = gc.getInfoTypeForString("PROMOTION_SHOCK2")
		p_formation2 = gc.getInfoTypeForString("PROMOTION_FORMATION2")
		p_heal = gc.getInfoTypeForString("PROMOTION_HEAL")
		p_heal2 = gc.getInfoTypeForString("PROMOTION_HEAL2")
		p_combat3 = gc.getInfoTypeForString("PROMOTION_COMBAT3")
		p_defence3 = gc.getInfoTypeForString("PROMOTION_DEFENCE3")
		p_medic2 = gc.getInfoTypeForString("PROMOTION_MEDIC2")
		p_attack3 = gc.getInfoTypeForString("PROMOTION_ATTACK3")
		p_defence3 = gc.getInfoTypeForString("PROMOTION_DEFENCE3")
		p_barrage3 = gc.getInfoTypeForString("PROMOTION_BARRAGE3")
	###def specialist Promotion (end) ###

#####################################
### - UNIQUE UNIT UPGRADE (1/2) - ###
#####################################
	### filter unique unit upgrade ###
		if heroUnit.getUnitType() in unitfilter:
			unitUP = 0

		#######################################################
		### - Artillery upgraded to a Howitzer (part 1/2) - ###
		#######################################################
    			if ( (heroUnit.getUnitType()==u_Arty) and (heroUnit.getLevel() >= 5) and (heroUnit.isHasPromotion(p_freeup)==false) ):
				chance = CyGame().getSorenRandNum(100, "Random for Howitzer upgrade")
				if chance >= 40:
					heroUnit.setHasPromotion(p_freeup, true)
					unitUP = 1

		###############################################################
		### - Modern Armor upgraded to a Koenigstieger (part 1/2) - ###
		###############################################################
    			if ( (  (heroUnit.getUnitType()==u_mArmor) or (heroUnit.getUnitType()==u_mArmorD) or (heroUnit.getUnitType()==u_mArmorS)  ) and (heroUnit.getLevel() >= 6) ):
				pPlayer = gc.getPlayer(heroUnit .getOwner())
				if ( ( gc.getTeam(pPlayer.getTeam()).isHasTech(gc.getInfoTypeForString("TECH_ARTIFICIAL_INTELLIGENCE")) == true ) and (heroUnit.isHasPromotion(p_freeup)==false) ):
					chance = CyGame().getSorenRandNum(100, "Random for Koenigstieger upgrade")
					if chance >= 70:
						heroUnit.setHasPromotion(p_freeup, true)
						unitUP = 1

	### ausgabe ###
			if ( unitUP == 1 ):
				heroUnitPlayer = gc.getPlayer(heroUnit.getOwner())
				cheroUnit = PyInfo.UnitInfo(heroUnit.getUnitType())
				CyInterface().addMessage(heroUnitPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_UNIQUE_UNIT_GAMETXT1",(cheroUnit.getDescription(),unitUP)),'',0,'Art/Interface/Buttons/promotions/freeupgrade.dds',ColorTypes(11),heroUnit.getX(),heroUnit.getY(),True,True)
				### message: Your %s gained a Free Upgrade Promotion! ###

########################################
### - Unit gained a Berzerker Perk - ###
########################################
		if (heroUnit.isHasPromotion(p_atk2)==true):
			if ( (heroUnit.getExperience() > 10) and (heroUnit.isMadeAttack()==true) ):
				chance = CyGame().getSorenRandNum(100, "Random for Berzerker prom")
				if chance >= 92:

					promBerzerker1 = gc.getInfoTypeForString("PROMOTION_BERZERKER1")
					promBerzerker2 = gc.getInfoTypeForString("PROMOTION_BERZERKER2")
					promBerzerker3 = gc.getInfoTypeForString("PROMOTION_BERZERKER3")
					promBP = 0

					if ( (heroUnit.isHasPromotion(promBerzerker3)==true) and (heroUnit.isHasPromotion(promBerzerker1)==false) ):
						heroUnit.setHasPromotion(promBerzerker1, true)
						promBP = promBerzerker1
					elif ( (heroUnit.isHasPromotion(promBerzerker2)==true) and (heroUnit.isHasPromotion(promBerzerker3)==false)):
						heroUnit.setHasPromotion(promBerzerker3, true)
						heroUnit.setHasPromotion(promBerzerker2, false)
						promBP = promBerzerker3
					elif ( (heroUnit.isHasPromotion(promBerzerker1)==true) and (heroUnit.isHasPromotion(promBerzerker2)==false) ):
						heroUnit.setHasPromotion(promBerzerker2, true)
						heroUnit.setHasPromotion(promBerzerker1, false)
						promBP = promBerzerker2
					elif ( (heroUnit.isHasPromotion(promBerzerker3)==false) and (heroUnit.isHasPromotion(promBerzerker2)==false) and (heroUnit.isHasPromotion(promBerzerker1)==false) ):
						heroUnit.setHasPromotion(promBerzerker1, true)
						promBP = promBerzerker1

			### ausgabe ###
					if ( promBP != 0 ):
						pLoserUnit = argsList[1]
						pLoserUnitPlayer = gc.getPlayer(pLoserUnit.getOwner())
						heroUnitPlayer = gc.getPlayer(heroUnit.getOwner())
						cheroUnit = PyInfo.UnitInfo(heroUnit.getUnitType())
						iX = heroUnit.getX()
						iY = heroUnit.getY()
						CyInterface().addMessage(heroUnitPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_PERK_GAMETXT1",(cheroUnit.getDescription(),PyHelpers.PyInfo.PromotionInfo(promBP).getDescription())),'',0,gc.getPromotionInfo(promBP).getButton(),ColorTypes(12),iX,iY,True,True)
						### message: Your %s gained a %s Perk! ###
						CyInterface().addMessage(pLoserUnitPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_PERK_GAMETXT2",(cheroUnit.getDescription(),PyHelpers.PyInfo.PromotionInfo(promBP).getDescription())),'',0,gc.getPromotionInfo(promBP).getButton(),ColorTypes(7),iX,iY,True,True)
						### message: An enemy %s gained a %s Perk! ###

#######################################
### - Unit gained a Stalwart Perk - ###
#######################################
		if (heroUnit.isHasPromotion(p_df2)==true):
			if ( (heroUnit.getExperience() > 10) and (heroUnit.isMadeAttack()==false) ):
				chance = CyGame().getSorenRandNum(100, "Random for Stalwart prom")
				if chance >= 92:

					promStalwart1 = gc.getInfoTypeForString("PROMOTION_STALWART1")
					promStalwart2 = gc.getInfoTypeForString("PROMOTION_STALWART2")
					promStalwart3 = gc.getInfoTypeForString("PROMOTION_STALWART3")
					promBP = 0

					if ( (heroUnit.isHasPromotion(promStalwart3)==true) and (heroUnit.isHasPromotion(promStalwart1)==false) ):
						heroUnit.setHasPromotion(promStalwart1, true)
						promBP = promStalwart1
					elif ( (heroUnit.isHasPromotion(promStalwart2)==true) and (heroUnit.isHasPromotion(promStalwart3)==false) ):
						heroUnit.setHasPromotion(promStalwart3, true)
						heroUnit.setHasPromotion(promStalwart2, false)
						promBP = promStalwart3
					elif ( (heroUnit.isHasPromotion(promStalwart1)==true) and (heroUnit.isHasPromotion(promStalwart2)==false) ):
						heroUnit.setHasPromotion(promStalwart2, true)
						heroUnit.setHasPromotion(promStalwart1, false)
						promBP = promStalwart2
					elif ( (heroUnit.isHasPromotion(promStalwart3)==false) and (heroUnit.isHasPromotion(promStalwart2)==false) and (heroUnit.isHasPromotion(promStalwart1)==false) ):
						heroUnit.setHasPromotion(promStalwart1, true)
						promBP = promStalwart1

			### ausgabe ###
					if ( promBP != 0 ):
						pLoserUnit = argsList[1]
						pLoserUnitPlayer = gc.getPlayer(pLoserUnit.getOwner())
						heroUnitPlayer = gc.getPlayer(heroUnit.getOwner())
						cheroUnit = PyInfo.UnitInfo(heroUnit.getUnitType())
						iX = heroUnit.getX()
						iY = heroUnit.getY()
						CyInterface().addMessage(heroUnitPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_PERK_GAMETXT1",(cheroUnit.getDescription(),PyHelpers.PyInfo.PromotionInfo(promBP).getDescription())),'',0,gc.getPromotionInfo(promBP).getButton(),ColorTypes(12),iX,iY,True,True)
						### message: Your %s gained a %s Perk! ###
						CyInterface().addMessage(pLoserUnitPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_PERK_GAMETXT2",(cheroUnit.getDescription(),PyHelpers.PyInfo.PromotionInfo(promBP).getDescription())),'',0,gc.getPromotionInfo(promBP).getButton(),ColorTypes(7),iX,iY,True,True)
						### message: An enemy %s gained a %s Perk! ###

####################################
### - Unit gained a Hero Trait - ###
####################################

		#hero1 = 6
		if (heroUnit.getExperience() > 6):

			clvl_POOR = 0
			clvl_FLEDGLING = 0
			clvl_DEVELOPING = 0
			clvl_REFINED = 0
			clvl_INFLUENTIAL = 0
			clvl_LEGENDARY = 0
	### rmore is the base chance for a hero unit e.g. 100 means 1% chance to get a hero unit after a fight ###
			rmore = 100
			heroUnitPlayer = gc.getPlayer(heroUnit.getOwner())

	### checks all the cities of the herounit player ###
	### and remenber all the different culture lvls of the cities ###
			for iCity in range(heroUnitPlayer.getNumCities()):
				pCity = heroUnitPlayer.getCity(iCity)
				if ( pCity.getCultureLevel()==gc.getInfoTypeForString("CULTURELEVEL_POOR") ):
					clvl_POOR += 1
				if ( pCity.getCultureLevel()==gc.getInfoTypeForString("CULTURELEVEL_FLEDGLING") ):
					clvl_FLEDGLING += 1
				if ( pCity.getCultureLevel()==gc.getInfoTypeForString("CULTURELEVEL_DEVELOPING") ):
					clvl_DEVELOPING += 1
				if ( pCity.getCultureLevel()==gc.getInfoTypeForString("CULTURELEVEL_REFINED") ):
					clvl_REFINED += 1
				if ( pCity.getCultureLevel()==gc.getInfoTypeForString("CULTURELEVEL_INFLUENTIAL") ):
					clvl_INFLUENTIAL += 1
				if ( pCity.getCultureLevel()==gc.getInfoTypeForString("CULTURELEVEL_LEGENDARY") ):
					clvl_LEGENDARY += 1
	### more cities with higher culture lvl increase the chance (lower the rmore value) to get a hero unit ###
			if ( clvl_POOR >= 4 ):
				rmore = rmore - 1
			if ( clvl_POOR >= 8 ):
				rmore = rmore - 1
			if ( clvl_FLEDGLING >= 4 ):
				rmore = rmore - 2
			if ( clvl_FLEDGLING >= 8 ):
				rmore = rmore - 2
			if ( clvl_DEVELOPING >= 4 ):
				rmore = rmore - 4
			if ( clvl_DEVELOPING >= 8 ):
				rmore = rmore - 4
			if ( clvl_REFINED >= 4 ):
				rmore = rmore - 8
			if ( clvl_REFINED >= 8 ):
				rmore = rmore - 8
			if ( clvl_INFLUENTIAL >= 4 ):
				rmore = rmore - 16
			if ( clvl_INFLUENTIAL >= 8 ):
				rmore = rmore - 16
			if ( clvl_LEGENDARY >= 1 ):
				rmore = rmore - 5
			if ( clvl_LEGENDARY >= 4 ):
				rmore = rmore - 32
			if ( clvl_LEGENDARY >= 8 ):
				rmore = rmore - 32
	### the maximum chance is (in my mod) 5% (rmore = 20) ###
			# Maximum Chance = 5% #
			if ( rmore <= 20 ):
				rmore = 20
			chance = CyGame().getSorenRandNum(rmore, "Heroic Units")
			#CyInterface().addMessage(heroUnitPlayer.getID(),True,15,"%d %d %d %d %d %d r%d chance%d" %(clvl_POOR, clvl_FLEDGLING, clvl_DEVELOPING, clvl_REFINED, clvl_INFLUENTIAL, clvl_LEGENDARY, rmore, chance),'',1,'Art/Interface/Buttons/promotions/Stalwart1.dds',ColorTypes(7),-1,-1,True,True)
			if (chance == 0):

				hero2 = 12
				hero3 = 20
				hero4 = 28
				hero5 = 42
				hero6 = 56
				heros = 0
				promHero1 = gc.getInfoTypeForString("PROMOTION_HERO1")
				promHero2 = gc.getInfoTypeForString("PROMOTION_HERO2")
				promHero3 = gc.getInfoTypeForString("PROMOTION_HERO3")
				promHero4 = gc.getInfoTypeForString("PROMOTION_HERO4")
				promHero5 = gc.getInfoTypeForString("PROMOTION_HERO5")
				promHero = 0
	### if you have no city with legendary culture lvl --> moreheros = 5; that means if there are more than 5 hero units in the whole game you dont get the hero promotion ###
				moreheros = 5
	### if you have a city with legendary culture lvl ---> moreheros = 5; that means if there are more than 10 hero units in the whole game you dont get the hero promotion ###
	### that means without worldbuilder there are at maximum 10 hero units in one game (if some1 have a city with legendary culture lvl) ###
				if ( clvl_LEGENDARY >= 1 ):
					moreheros = 10

	### check how many hero units are in the whole game ###
				for iiPlayer in range(gc.getMAX_PLAYERS()):
					ppPlayer = PyPlayer(iiPlayer)
					if (ppPlayer.isAlive()):
						unitList = ppPlayer.getUnitList()
						for iiUnit in range(len(unitList)):
							ppUnit = unitList[iiUnit]
							if ( ppUnit.isHasPromotion(promHero1)==true or ppUnit.isHasPromotion(promHero2)==true or ppUnit.isHasPromotion(promHero3)==true or ppUnit.isHasPromotion(promHero4)==true or ppUnit.isHasPromotion(promHero5)==true ):
								heros += 1
			# Avatar Trait #
				# x x x t f #
				if ((heroUnit.isHasPromotion(promHero4)==true) and (heroUnit.getExperience() > hero5) and (heroUnit.isHasPromotion(promHero5)==false)):
					heroUnit.setHasPromotion(promHero4, false)
					heroUnit.setHasPromotion(promHero5, true)
					promHero = promHero5
			# Legendary Hero #
				# x x t f x #
				elif ((heroUnit.isHasPromotion(promHero3)==true) and (heroUnit.getExperience() > hero4) and (heroUnit.isHasPromotion(promHero4)==false)):
					heroUnit.setHasPromotion(promHero3, false)
					heroUnit.setHasPromotion(promHero4, true)
					promHero = promHero4
			# Hero #
				# x t f x x #
				elif ((heroUnit.isHasPromotion(promHero2)==true) and (heroUnit.getExperience() > hero3) and (heroUnit.isHasPromotion(promHero3)==false)):
					heroUnit.setHasPromotion(promHero2, false)
					heroUnit.setHasPromotion(promHero3, true)
					promHero = promHero3
			# Extraordinary #
				# t f x x x #
				elif ((heroUnit.isHasPromotion(promHero1)==true) and (heroUnit.getExperience() > hero2) and (heroUnit.isHasPromotion(promHero2)==false)):
					heroUnit.setHasPromotion(promHero1, false)
					heroUnit.setHasPromotion(promHero2, true)
					promHero = promHero2
			# Exceptional #
	### this is the initial hero promotion function for new hero units gained in battles ###
				# f f f f f #
				elif ((heroUnit.isHasPromotion(promHero1)==false) and (heroUnit.isHasPromotion(promHero2)==false) and (heroUnit.isHasPromotion(promHero3)==false) and (heroUnit.isHasPromotion(promHero4)==false) and (heroUnit.isHasPromotion(promHero5)==false) ):
	### this is the check if there are more than 5 or 10 hero units in the game. if not, give the pUnit the hero promotion ###
	### the rest of the code (below and above) is for the hero promotion upgrade system ###
					if ( heros < moreheros ):
						heroUnit.setHasPromotion(promHero1, true)
						promHero = promHero1
				# f f f f t #
				elif ((heroUnit.isHasPromotion(promHero1)==false) and (heroUnit.isHasPromotion(promHero2)==false) and (heroUnit.isHasPromotion(promHero3)==false) and (heroUnit.isHasPromotion(promHero4)==false) and (heroUnit.isHasPromotion(promHero5)==true) ):
					heroUnit.setHasPromotion(promHero1, true)
					promHero = promHero1
				# f f f t t #
				elif ((heroUnit.isHasPromotion(promHero1)==false) and (heroUnit.isHasPromotion(promHero2)==false) and (heroUnit.isHasPromotion(promHero3)==false) and (heroUnit.isHasPromotion(promHero4)==true) and (heroUnit.isHasPromotion(promHero5)==true) and (heroUnit.getExperience() > hero6) ):
					heroUnit.setHasPromotion(promHero1, true)
					promHero = promHero1
				# f f t t t #
				elif ((heroUnit.isHasPromotion(promHero1)==false) and (heroUnit.isHasPromotion(promHero2)==false) and (heroUnit.isHasPromotion(promHero3)==true) and (heroUnit.isHasPromotion(promHero4)==true) and (heroUnit.isHasPromotion(promHero5)==true)):
					heroUnit.setHasPromotion(promHero1, true)
					promHero = promHero1
				# f t t t t #
				elif ((heroUnit.isHasPromotion(promHero1)==false) and (heroUnit.isHasPromotion(promHero2)==true) and (heroUnit.isHasPromotion(promHero3)==true) and (heroUnit.isHasPromotion(promHero4)==true) and (heroUnit.isHasPromotion(promHero5)==true)):
					heroUnit.setHasPromotion(promHero1, true)
					promHero = promHero1

	### ausgabe ###
				if ( promHero != 0 ):
					pLoserUnit = argsList[1]
					pLoserUnitPlayer = gc.getPlayer(pLoserUnit.getOwner())
					cheroUnit = PyInfo.UnitInfo(heroUnit.getUnitType())
					iX = heroUnit.getX()
					iY = heroUnit.getY()
					CyInterface().addMessage(heroUnitPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_HERO_GAMETXT1",(cheroUnit.getDescription(),PyHelpers.PyInfo.PromotionInfo(promHero).getDescription())),'',0,gc.getPromotionInfo(promHero).getButton(),ColorTypes(8),iX,iY,True,True)
					### message: Your %s gained a %s Trait! ###
					CyInterface().addMessage(pLoserUnitPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_HERO_GAMETXT2",(cheroUnit.getDescription(),PyHelpers.PyInfo.PromotionInfo(promHero).getDescription())),'',0,gc.getPromotionInfo(promHero).getButton(),ColorTypes(7),iX,iY,True,True)
					### message: An enemy %s gained a %s Trait! ###

#############################
### Specialist Promotions ###
#############################
		lSpecProm = []

	#############################################
	### - Unit gained a Combat VI Promotion - ###
	#############################################
		if ( heroUnit.isHasPromotion(p_combat5)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_COMBAT6"))==false ):
				if (heroUnit.getExperience() > 17):
					chance = CyGame().getSorenRandNum(100, "Random for Combat 6 prom")
					if chance >= 80:
						p_fnP = gc.getInfoTypeForString("PROMOTION_COMBAT6")
						heroUnit.setHasPromotion(p_fnP, true)
						lSpecProm.append(p_fnP)

	###########################################
	### - Unit gained a Drill V Promotion - ###
	###########################################
		if ( heroUnit.isHasPromotion(p_drill4)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_DRILL5"))==false ):
				if (heroUnit.getExperience() > 10):
					chance = CyGame().getSorenRandNum(100, "Random for Drill 5 prom")
					if chance >= 60:
						p_fnP = gc.getInfoTypeForString("PROMOTION_DRILL5")
						heroUnit.setHasPromotion(p_fnP, true)
						lSpecProm.append(p_fnP)

	################################################
	### - Unit gained a Flanking III Promotion - ###
	################################################
		if ( heroUnit.isHasPromotion(p_flanking2)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_FLANKING3"))==false ):
				if (heroUnit.getExperience() > 17):
					chance = CyGame().getSorenRandNum(100, "Random for Flanking 3 prom")
					if chance >= 80:
						p_fnP = gc.getInfoTypeForString("PROMOTION_FLANKING3")
						heroUnit.setHasPromotion(p_fnP, true)
						lSpecProm.append(p_fnP)

	#####################################################
	### - Unit gained a City Garrision IV Promotion - ###
	#####################################################
		if ( heroUnit.isHasPromotion(p_cg3)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_CITY_GARRISON4"))==false ):
				if (heroUnit.getExperience() > 10):
					if ( heroUnit.isMadeAttack()==false ):
						chance = CyGame().getSorenRandNum(100, "Random for City Garrison 4 prom")
						if chance >= 80:
							iX = heroUnit.plot().getX()
							iY = heroUnit.plot().getY()
							pPlot = CyMap().plot(iX,iY)
							if (pPlot.isCity()==true):
								p_fnP = gc.getInfoTypeForString("PROMOTION_CITY_GARRISON4")
								heroUnit.setHasPromotion(p_fnP, true)
								lSpecProm.append(p_fnP)

	##################################################
	### - Unit gained a City Raider IV Promotion - ###
	##################################################
		if ( heroUnit.isHasPromotion(p_craider3)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_CITY_RAIDER4"))==false ):
				if (heroUnit.getExperience() > 17):
					if ( heroUnit.isMadeAttack()==true ):
						chance = CyGame().getSorenRandNum(100, "Random for City Raider 4 prom")
						if chance >= 85:
							pLoser = argsList[1]
							iX = pLoser.plot().getX()
							iY = pLoser.plot().getY()
							pPlot = CyMap().plot(iX,iY)
							if (pPlot.isCity()==true):
								p_fnP = gc.getInfoTypeForString("PROMOTION_CITY_RAIDER4")
								heroUnit.setHasPromotion(p_fnP, true)
								lSpecProm.append(p_fnP)

	################################################
	### - Unit gained a Guerilla III Promotion - ###
	################################################
		if ( heroUnit.isHasPromotion(p_guerilla2)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_GUERILLA3"))==false ):
				if (heroUnit.getExperience() > 10):
					chance = CyGame().getSorenRandNum(100, "Random for Guerilla 3 prom")
					if chance >= 65:
						pLoser = argsList[1]
						ilX = pLoser.plot().getX()
						ilY = pLoser.plot().getY()
						plPlot = CyMap().plot(ilX,ilY)
						iX = heroUnit.plot().getX()
						iY = heroUnit.plot().getY()
						pPlot = CyMap().plot(iX,iY)
						if ( (pPlot.isHills()==true) or (plPlot.isHills()==true) ):
							p_fnP = gc.getInfoTypeForString("PROMOTION_GUERILLA3")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	################################################
	### - Unit gained a Woodsman III Promotion - ###
	################################################
		if ( heroUnit.isHasPromotion(p_woodsman2)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_WOODSMAN3"))==false ):
				if (heroUnit.getExperience() > 10):
					chance = CyGame().getSorenRandNum(100, "Random for Woodsman 3 prom")
					if chance >= 65:
						pLoser = argsList[1]
						ilX = pLoser.plot().getX()
						ilY = pLoser.plot().getY()
						plPlot = CyMap().plot(ilX,ilY)
						iX = heroUnit.plot().getX()
						iY = heroUnit.plot().getY()
						pPlot = CyMap().plot(iX,iY)
						if ( (pPlot.getFeatureType()==gc.getInfoTypeForString( 'FEATURE_JUNGLE' )) or (pPlot.getFeatureType()==gc.getInfoTypeForString( 'FEATURE_FOREST' )) or (plPlot.getFeatureType()==gc.getInfoTypeForString( 'FEATURE_JUNGLE' )) or (plPlot.getFeatureType()==gc.getInfoTypeForString( 'FEATURE_FOREST' )) ):
							p_fnP = gc.getInfoTypeForString("PROMOTION_WOODSMAN3")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	####################################################
	### - Unit gained a Desert Combat II Promotion - ###
	####################################################
		if ( heroUnit.isHasPromotion(p_desertc1)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_WARMTH2"))==false ):
				if (heroUnit.getExperience() > 17):
					chance = CyGame().getSorenRandNum(100, "Random for Desert Combat 2 prom")
					if chance >= 90:
						pLoserUnit = argsList[1]
						ilX = pLoserUnit.plot().getX()
						ilY = pLoserUnit.plot().getY()
						plPlot = CyMap().plot(ilX,ilY)
						iX = heroUnit.plot().getX()
						iY = heroUnit.plot().getY()
						pPlot = CyMap().plot(iX,iY)
						t_desert = gc.getInfoTypeForString("TERRAIN_DESERT") 
						if ( (pPlot.getTerrainType()==t_desert) or (plPlot.getTerrainType()==t_desert) ):
							p_fnP = gc.getInfoTypeForString("PROMOTION_WARMTH2")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	####################################################
	### - Unit gained a Arctic Combat II Promotion - ###
	####################################################
		if ( heroUnit.isHasPromotion(p_arcticc1)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_COLD2"))==false ):
				if (heroUnit.getExperience() > 17):
					chance = CyGame().getSorenRandNum(100, "Random for Arctic Combat 2 prom")
					if chance >= 90:
						pLoserUnit = argsList[1]
						ilX = pLoserUnit.plot().getX()
						ilY = pLoserUnit.plot().getY()
						plPlot = CyMap().plot(ilX,ilY)
						iX = heroUnit.plot().getX()
						iY = heroUnit.plot().getY()
						pPlot = CyMap().plot(iX,iY)
						t_tundra = gc.getInfoTypeForString("TERRAIN_TUNDRA")
						t_snow = gc.getInfoTypeForString("TERRAIN_SNOW") 
						if ( (pPlot.getTerrainType()==t_tundra) or (plPlot.getTerrainType()==t_tundra) or (pPlot.getTerrainType()==t_snow) or (plPlot.getTerrainType()==t_snow) ):
							p_fnP = gc.getInfoTypeForString("PROMOTION_COLD2")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	#############################################
	### - Unit gained a Pinch III Promotion - ###
	#############################################
		if ( heroUnit.isHasPromotion(p_pinch2)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_PINCH3"))==false ):
				if (heroUnit.getExperience() > 17):
					chance = CyGame().getSorenRandNum(100, "Random for Pinch 3 prom")
					if chance >= 80:
						pLoser = argsList[1]
    						if ( (pLoser.getUnitCombatType() == (gc.getInfoTypeForString("UNITCOMBAT_GUN")) ) and (heroUnit.getLevel() >= 3) ):
							p_fnP = gc.getInfoTypeForString("PROMOTION_PINCH3")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	##############################################
	### - Unit gained a Charge III Promotion - ###
	##############################################
		if ( heroUnit.isHasPromotion(p_charge2)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_CHARGE3"))==false ):
				if (heroUnit.getExperience() > 2):
					chance = CyGame().getSorenRandNum(100, "Random for Charge 3 prom")
					if chance >= 20:
						pLoser = argsList[1]
    						if ( (pLoser.getUnitCombatType() == (gc.getInfoTypeForString("UNITCOMBAT_SIEGE")) ) and (heroUnit.getLevel() >= 2) ):
							p_fnP = gc.getInfoTypeForString("PROMOTION_CHARGE3")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	###############################################
	### - Unit gained an Ambush III Promotion - ###
	###############################################
		if ( heroUnit.isHasPromotion(p_ambush2)==true ):
			if ( heroUnit.isHasPromotion(p_ambush3)==false ):
				if (heroUnit.getExperience() > 10):
					chance = CyGame().getSorenRandNum(100, "Random for Ambush 3 prom")
					if chance >= 80:
						pLoser = argsList[1]
    						if ( (pLoser.getUnitCombatType() == (gc.getInfoTypeForString("UNITCOMBAT_ARMOR")) ) and (heroUnit.getLevel() >= 3) ):
							p_fnP = p_ambush3
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	##############################################
	### - Unit gained an Ambush IV Promotion - ###
	##############################################
		if ( heroUnit.isHasPromotion(p_ambush3)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_AMBUSH4"))==false ):
				if ( (heroUnit.getExperience() > 40) and (heroUnit.isHasPromotion(p_combat3)==true) ):
					chance = CyGame().getSorenRandNum(100, "Random for Ambush 4 prom")
					if chance >= 95:
						pLoser = argsList[1]
    						if ( (pLoser.getUnitCombatType() == (gc.getInfoTypeForString("UNITCOMBAT_ARMOR")) ) and (heroUnit.getLevel() >= 6) ):
							p_fnP = gc.getInfoTypeForString("PROMOTION_AMBUSH4")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	#############################################
	### - Unit gained a Cover III Promotion - ###
	#############################################
		if ( heroUnit.isHasPromotion(p_cover2)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_COVER3"))==false ):
				if (heroUnit.getExperience() > 10):
					chance = CyGame().getSorenRandNum(100, "Random for Cover 3 prom")
					if chance >= 50:
						pLoser = argsList[1]
    						if ( (pLoser.getUnitCombatType() == (gc.getInfoTypeForString("UNITCOMBAT_ARCHER")) ) and (heroUnit.getLevel() >= 3) ):
							p_fnP = gc.getInfoTypeForString("PROMOTION_COVER3")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	#############################################
	### - Unit gained a Shock III Promotion - ###
	#############################################
		if ( heroUnit.isHasPromotion(p_shock2)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_SHOCK3"))==false ):
				if (heroUnit.getExperience() > 15):
					chance = CyGame().getSorenRandNum(100, "Random for Shock 3 prom")
					if chance >= 70:
						pLoser = argsList[1]
    						if ( (pLoser.getUnitCombatType() == (gc.getInfoTypeForString("UNITCOMBAT_MELEE")) ) and (heroUnit.getLevel() >= 3) ):
							p_fnP = gc.getInfoTypeForString("PROMOTION_SHOCK3")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	#################################################
	### - Unit gained a Formation III Promotion - ###
	#################################################
		if ( heroUnit.isHasPromotion(p_formation2)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_FORMATION3"))==false ):
				if (heroUnit.getExperience() > 10):
					chance = CyGame().getSorenRandNum(100, "Random for Formation 3 prom")
					if chance >= 70:
						pLoser = argsList[1]
    						if ( (pLoser.getUnitCombatType() == (gc.getInfoTypeForString("UNITCOMBAT_MOUNTED")) ) and (heroUnit.getLevel() >= 2) ):
							p_fnP = gc.getInfoTypeForString("PROMOTION_FORMATION3")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	############################################
	### - Unit gained a Heal III Promotion - ###
	############################################
		if ( heroUnit.isHasPromotion(p_heal2)==true ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_HEAL3"))==false ):
				if (heroUnit.getExperience() > 55):
					chance = CyGame().getSorenRandNum(100, "Random for Heal 3 prom")
					if chance >= 98:
						p_fnP = gc.getInfoTypeForString("PROMOTION_HEAL3")
						heroUnit.setHasPromotion(p_fnP, true)
						lSpecProm.append(p_fnP)

	###########################################
	### - Unit gained a Heal II Promotion - ###
	###########################################
		if ( heroUnit.isHasPromotion(p_heal)==true ):
			if ( heroUnit.isHasPromotion(p_heal2)==false ):
				if (heroUnit.getExperience() > 40):
					chance = CyGame().getSorenRandNum(100, "Random for Heal 2 prom")
					if chance >= 97:
						p_fnP = p_heal2
						heroUnit.setHasPromotion(p_fnP, true)
						lSpecProm.append(p_fnP)

	########################################
	### - Unit gained a Heal Promotion - ###
	########################################
		if ( (heroUnit.isHasPromotion(p_combat3)==true) or (heroUnit.isHasPromotion(p_defence3)==true) or (heroUnit.isHasPromotion(p_medic2)==true) ):
			if ( heroUnit.isHasPromotion(p_heal)==false ):
				if (heroUnit.getExperience() > 25):
					chance = CyGame().getSorenRandNum(100, "Random for Heal prom")
					if chance >= 95:
						p_fnP = p_heal
						heroUnit.setHasPromotion(p_fnP, true)
						lSpecProm.append(p_fnP)

	#############################################
	### - Unit gained a Attack IV Promotion - ###
	#############################################
		if ( heroUnit.isHasPromotion(p_attack3)==true ):
			if( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_ATTACK4"))==false ):
				if (heroUnit.getExperience() > 17):
					if ( heroUnit.isMadeAttack()==true ):
						chance = CyGame().getSorenRandNum(100, "Random for Attack 4 prom")
						if chance >= 80:
							p_fnP = gc.getInfoTypeForString("PROMOTION_ATTACK4")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	##############################################
	### - Unit gained a Defence IV Promotion - ###
	##############################################
		if ( heroUnit.isHasPromotion(p_defence3)==true ):
			if( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_DEFENCE4"))==false ):
				if (heroUnit.getExperience() > 5):
					if ( heroUnit.isMadeAttack()==false ):
						chance = CyGame().getSorenRandNum(100, "Random for Defence 4 prom")
						if chance >= 20:
							p_fnP = gc.getInfoTypeForString("PROMOTION_DEFENCE4")
							heroUnit.setHasPromotion(p_fnP, true)
							lSpecProm.append(p_fnP)

	##############################################
	### - Unit gained a Barrage IV Promotion - ###
	##############################################
		if ( heroUnit.isHasPromotion(p_barrage3)==true ):
			if( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_BARRAGE4"))==false ):
				if ( (heroUnit.getExperience() > 17) and (heroUnit.isHasPromotion(p_combat3)==true) ):
					chance = CyGame().getSorenRandNum(100, "Random for Barrage 4 prom")
					if chance >= 80:
						p_fnP = gc.getInfoTypeForString("PROMOTION_BARRAGE4")
						heroUnit.setHasPromotion(p_fnP, true)
						lSpecProm.append(p_fnP)

	### ausgabe ###
		if ( len(lSpecProm) > 0 ):
			n_prom = len(lSpecProm)
			position = 0
			while ( n_prom > 0 ):
				n_prom -= 1
				p_fnP = lSpecProm[position]
				position += 1
				pLoserUnit = argsList[1]
				cheroUnit = PyInfo.UnitInfo(heroUnit.getUnitType())
				iX = heroUnit.getX()
				iY = heroUnit.getY()
				CyInterface().addMessage(gc.getPlayer(heroUnit.getOwner()).getID(),True,15,CyTranslator().getText("TXT_KEY_SPEC_PROM_GAMETXT1",(cheroUnit.getDescription(),PyHelpers.PyInfo.PromotionInfo(p_fnP).getDescription())),'',0,gc.getPromotionInfo(p_fnP).getButton(),ColorTypes(9),iX,iY,True,True)
				### message: Your %s gained a %s Promotion! ###
				CyInterface().addMessage(gc.getPlayer(pLoserUnit.getOwner()).getID(),True,15,CyTranslator().getText("TXT_KEY_SPEC_PROM_GAMETXT2",(cheroUnit.getDescription(),PyHelpers.PyInfo.PromotionInfo(p_fnP).getDescription())),'',0,gc.getPromotionInfo(p_fnP).getButton(),ColorTypes(7),iX,iY,True,True)
				### message: An Enemy %s gained a %s Promotion! ###

##############################################################################
### - Unit gain a free Upgrade Promotion from Leonardo Wonder (part 1/3) - ###
##############################################################################

	### filter ###
		if ( ( heroUnit.getExperience() >= 3 ) and (heroUnit.isHasPromotion(p_freeup)==false) ):
	### 20% chance for old units to get a upgrade promotion if the win a fight within the own territory ###
			chance = CyGame().getSorenRandNum(100, "Random for free Upgrade")
			if chance >= 20:
	### check if the unit can upgrade ###
				upgposs = 0
				for iUnitC in range(gc.getNumUnitInfos()):
					if ( heroUnit.canUpgrade( iUnitC, true) == true ):
						upgposs = upgposs +1
				if ( upgposs > 0 ):
	### check if the player has the leonardo wonder ###
					pPlayer = gc.getPlayer(heroUnit.getOwner())
					for iCity in range(pPlayer.getNumCities()):
						pCity = pPlayer.getCity(iCity)
						if pCity.hasBuilding(gc.getInfoTypeForString("BUILDING_LEONARDOS_WORKSHOP")):

							iX = heroUnit.plot().getX()
							iY = heroUnit.plot().getY()
							pPlot = CyMap().plot(iX,iY)
							i_fort = gc.getInfoTypeForString("IMPROVEMENT_FORT")

	### get a free upgrade promotion if the unit is not in a city or fort ###
							if ( (pPlot.isCity()==false) and (pPlot.getImprovementType()!=i_fort) ):
								heroUnit.setHasPromotion(p_freeup, true)
			### ausgabe1 ###
								cheroUnit = PyInfo.UnitInfo(heroUnit.getUnitType())
								CyInterface().addMessage(pPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_LEONARDO_WONDER_GAMETXT2",(cheroUnit.getDescription(),iX)),'',0,'Art/Interface/Buttons/promotions/freeupgrade.dds',ColorTypes(11),iX,iY,True,True)
								### message: Your %s gained a Free Upgrade Promotion! ###

	### upgrade unit if it is in a city or fort ###
							if ( (pPlot.isCity()==true) or (pPlot.getImprovementType()==i_fort) ):
								heroUnit.setMoves(1)
		### possible upgrade for unit (list) ###
								lUnitCx = []
								upgposs = 0
								for iUnitC in range(gc.getNumUnitInfos()):
									if ( heroUnit.canUpgrade( iUnitC, true) == true ):
										lUnitCx.append(iUnitC)
										upgposs += 1
		### choose one of the possibil upgrades in the list ###
								if ( upgposs > 0 ):
									iRand = CyGame().getSorenRandNum( upgposs, "Random which new Up")
									pnewUp = lUnitCx[iRand]
									pNewUnit = pPlayer.initUnit( pnewUp, iX, iY, UnitAITypes.NO_UNITAI )
									pNewUnit.convert(heroUnit)
		### check if the unit was a musketman with musket promotion - if yes, remove it ###
									if ( pNewUnit.getUnitClassType() != gc.getInfoTypeForString("UNITCLASS_MUSKETMAN") ):
										if ( pNewUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_MUSKETE"))==true ):
											pNewUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_MUSKETE"), false)
									pNewUnit.finishMoves()
			### ausgabe2 ###
									cUnit = PyInfo.UnitInfo(heroUnit.getUnitType())
									ccUnit = PyInfo.UnitInfo(pNewUnit.getUnitType())
									CyInterface().addMessage(pPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_LEONARDO_WONDER_GAMETXT1",(cUnit.getDescription(), ccUnit.getDescription())),'AS2D_UNIT_BUILD_UNIQUE_UNIT',0,'Art/Interface/Buttons/promotions/freeupgrade.dds',ColorTypes(11),iX,iY,True,True)
									### message: Your %s upgraded to a %s! ###

###############################################################################
### - Remove free Muskete Promotion from all Units expect Musketman (1/2) - ###
###############################################################################
		if ( heroUnit.getUnitClassType() != gc.getInfoTypeForString("UNITCLASS_MUSKETMAN") ):
			if ( heroUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_MUSKETE"))==true ):
				heroUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_MUSKETE"), false)

########################################################################################################################################			

class adTech:						
	def onTechAcquired(self, argsList):

		iTechType, iTeam, iPlayer, bAnnounce = argsList

##########################################
### City Guard Tech Upgrade (RAILROAD) ###
##########################################
		if ( iTechType == (gc.getInfoTypeForString("TECH_RAILROAD")) ):
			uc_warrior = gc.getInfoTypeForString("UNITCLASS_WARRIOR")
			uc_spearman = gc.getInfoTypeForString("UNITCLASS_SPEARMAN")
			uc_axeman = gc.getInfoTypeForString("UNITCLASS_AXEMAN")
			pPlayer = gc.getPlayer(iPlayer)

	### check if the city has the city guard improvement ###
			for iCity in range(pPlayer.getNumCities()):
				pCity = pPlayer.getCity(iCity)
				if pCity.hasBuilding(gc.getInfoTypeForString('BUILDING_STADTWACHE')):
	### check if the city has warrior, spearman or axeman city guard(s)... ###
					iX = pCity.plot().getX()
					iY = pCity.plot().getY()
					pCityName = pCity.getName()
					lCGUnit = []
					lCGUnitT = []
					CGup = 0
					for iUnit in range(pCity.plot().getNumUnits()):
						pUnit = pCity.plot().getUnit(iUnit)
						if ( pUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_CITY_GUARD")) ):
							if ( (pUnit.getUnitClassType() == uc_warrior) or (pUnit.getUnitClassType() == uc_spearman) ):
								lCGUnit.append(pUnit)
								CGUnitT = 0
								lCGUnitT.append(CGUnitT)
								CGup += 1
							if ( pUnit.getUnitClassType() == uc_axeman ):
								lCGUnit.append(pUnit)
								CGUnitT = 1
								lCGUnitT.append(CGUnitT)
								CGup += 1
	### ...if yes, upgrade the city guard unit(s) to pikeman or maceman ###
					if ( CGup > 0 ):
						u_pikeman = gc.getInfoTypeForString("UNIT_PIKEMAN")
						u_maceman = gc.getInfoTypeForString("UNIT_MACEMAN")
						for i in range(CGup):
							pCGUnit = lCGUnit[i]
							if ( lCGUnitT[i] == 0 ):
								pNewUnit = pPlayer.initUnit( u_pikeman, iX, iY, UnitAITypes.NO_UNITAI )
							if ( lCGUnitT[i] == 1 ):
								pNewUnit = pPlayer.initUnit( u_maceman, iX, iY, UnitAITypes.NO_UNITAI )
							pNewUnit.convert(pCGUnit)
	### ausgabe ###
							cpUnit = PyInfo.UnitInfo(pCGUnit.getUnitType())
							cpNewUnit = PyInfo.UnitInfo(pNewUnit.getUnitType())
							CyInterface().addMessage(pPlayer.getID(),True,15,"",'',1,'Art/Interface/Buttons/promotions/freeupgrade.dds',ColorTypes(11),iX,iY,True,True)
							CyInterface().addMessage(pPlayer.getID(),false,15,CyTranslator().getText("TXT_KEY_CITY_GUARD_UPGRADE_GAMETXT1",(cpUnit.getDescription(), pCityName, cpNewUnit.getDescription())),'',0,'Art/Interface/Buttons/promotions/freeupgrade.dds',ColorTypes(44),iX,iY,True,True)
							### message: Your %s City Guard in %s Upgraded to a %s! ###

############################################
### City Guard Tech Upgrade (COMPOSITES) ###
############################################
		if ( iTechType == (gc.getInfoTypeForString("TECH_COMPOSITES")) ):
			uc_warrior = gc.getInfoTypeForString("UNITCLASS_WARRIOR")
			uc_spearman = gc.getInfoTypeForString("UNITCLASS_SPEARMAN")
			uc_axeman = gc.getInfoTypeForString("UNITCLASS_AXEMAN")
			uc_pikeman = gc.getInfoTypeForString("UNITCLASS_PIKEMAN")
			uc_maceman = gc.getInfoTypeForString("UNITCLASS_MACEMAN")
			uc_grenadier = gc.getInfoTypeForString("UNITCLASS_GRENADIER")
			uc_musketman = gc.getInfoTypeForString("UNITCLASS_MUSKETMAN")
			uc_rifleman = gc.getInfoTypeForString("UNITCLASS_RIFLEMAN")
			pPlayer = gc.getPlayer(iPlayer)

	### check if the city has the city guard improvement ###
			for iCity in range(pPlayer.getNumCities()):
				pCity = pPlayer.getCity(iCity)
				if pCity.hasBuilding(gc.getInfoTypeForString('BUILDING_STADTWACHE')):
	### check if the city has warrior, spearman, axeman, pikeman, maceman, grenadier, musketman or rifleman city guard(s)... ###
					iX = pCity.plot().getX()
					iY = pCity.plot().getY()
					pCityName = pCity.getName()
					lCGUnit = []
					CGup = 0
					for iUnit in range(pCity.plot().getNumUnits()):
						pUnit = pCity.plot().getUnit(iUnit)
						if ( pUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_CITY_GUARD")) ):
							if ( (pUnit.getUnitClassType() == uc_warrior) or (pUnit.getUnitClassType() == uc_spearman) or (pUnit.getUnitClassType() == uc_axeman) or (pUnit.getUnitClassType() == uc_pikeman) or (pUnit.getUnitClassType() == uc_maceman) or (pUnit.getUnitClassType() == uc_grenadier) or (pUnit.getUnitClassType() == uc_musketman) or (pUnit.getUnitClassType() == uc_rifleman) ):
								lCGUnit.append(pUnit)
								CGup += 1
	### ...if yes, upgrade the city guard unit(s) to machinegun ###
					if ( CGup > 0 ):
						u_machinegun = gc.getInfoTypeForString("UNIT_MACHINE_GUN")
						for i in range(CGup):
							pCGUnit = lCGUnit[i]
							pNewUnit = pPlayer.initUnit( u_machinegun, iX, iY, UnitAITypes.NO_UNITAI )
							pNewUnit.convert(pCGUnit)
		### check if the unit was a musketman with musket promotion - if yes, remove it ###
							if ( pNewUnit.getUnitClassType() != gc.getInfoTypeForString("UNITCLASS_MUSKETMAN") ):
								if ( pNewUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_MUSKETE"))==true ):
									pNewUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_MUSKETE"), false)
	### ausgabe ###
							cpUnit = PyInfo.UnitInfo(pCGUnit.getUnitType())
							cpNewUnit = PyInfo.UnitInfo(pNewUnit.getUnitType())
							CyInterface().addMessage(pPlayer.getID(),True,15,"",'',1,'Art/Interface/Buttons/promotions/freeupgrade.dds',ColorTypes(11),iX,iY,True,True)
							CyInterface().addMessage(pPlayer.getID(),false,15,CyTranslator().getText("TXT_KEY_CITY_GUARD_UPGRADE_GAMETXT1",(cpUnit.getDescription(), pCityName, cpNewUnit.getDescription())),'',0,'Art/Interface/Buttons/promotions/freeupgrade.dds',ColorTypes(44),iX,iY,True,True)
							### message: Your %s City Guard in %s Upgraded to a %s! ###
						
########################################
### - Flak88 if you acquire Flight - ###
########################################
		if ( iTechType == (gc.getInfoTypeForString("TECH_FLIGHT")) ):
			pPlayer = gc.getPlayer(iPlayer)
	### place flak(s) in capital city ###
			for iCity in range(pPlayer.getNumCities()):
				pCity = pPlayer.getCity(iCity)
				if ( pCity.isCapital() == true ):
					u_flak = gc.getInfoTypeForString("UNIT_FLAK88")
					iX = pCity.plot().getX()
					iY = pCity.plot().getY()
					for i in range(2):
						pNewUnit = pPlayer.initUnit( u_flak, iX, iY, UnitAITypes.UNITAI_DEFENSE_AIR )
				### last flak is city flak for capital city ###
					pNewUnit.setHasPromotion(gc.getInfoTypeForString( "PROMOTION_DRILL1" ), true)
					pNewUnit.setHasPromotion(gc.getInfoTypeForString( "PROMOTION_DRILL2" ), true)
					pNewUnit.setHasPromotion(gc.getInfoTypeForString( "PROMOTION_CITY_GUARD" ), true)
					pNewUnit.setName("City FLAK")
					pNewUnit.finishMoves()
	### ausgabe ###
					CyInterface().addMessage(pPlayer.getID(),true,15,"",'',1,'Art/Interface/Buttons/Units/Flak88.dds',ColorTypes(5),iX,iY,True,True)
					CyInterface().addMessage(pPlayer.getID(),false,15,CyTranslator().getText("TXT_KEY_FREE_FLAK_GAMETXT1",(pCity.getName(),iX)),'AS2D_UNIT_BUILD_FIGHTER',0,'Art/Interface/Buttons/Units/Flak88.dds',ColorTypes(11),iX,iY,True,True)
					### message: FLAK Units in %s created! ###

################################################
### - free Units if you acquire Combustion - ###
### the first:  3Z* 2BP				   ###
### the second: 2Z  2BP		Z =Zeppelin	   ###	
### the third:  2Z  1BP		BP=Biplane	   ###
### the fourth: 1Z  1BP				   ###
### the fifth:  1Z				   ###
################################################
		t_Comb = gc.getInfoTypeForString("TECH_COMBUSTION")
		if ( iTechType == t_Comb ):
			pPlayer = gc.getPlayer(iPlayer)
	### checks who is the firsd, second, ... ###
			platzierung = 0
			for iiPlayer in range(gc.getMAX_PLAYERS()):
				ppPlayer = gc.getPlayer(iiPlayer)
				if ( gc.getTeam(ppPlayer.getTeam()).isHasTech(t_Comb) == true ):
					platzierung = platzierung + 1
	### place the units (depends on platzierung value) ###
			for iCity in range(pPlayer.getNumCities()):
				pCity = pPlayer.getCity(iCity)
				if ( pCity.isCapital() == true ):
					
					u_Zeppelin = gc.getInfoTypeForString("UNIT_ZEPPELIN")
					u_Biplane = gc.getInfoTypeForString("UNIT_CAMEL_FIGHTER")
					iX = pCity.plot().getX()
					iY = pCity.plot().getY()

			### ausgabe1 ###
					if ( platzierung <= 5 ):
						CyInterface().addMessage(pPlayer.getID(),True,15,"",'',1,'Art/Interface/Buttons/Units/zeppelin2.dds',ColorTypes(5),iX,iY,True,True)
					if ( platzierung == 1 ):
						for i in range(2):
							pPlayer.initUnit( u_Zeppelin, iX, iY, UnitAITypes.UNITAI_ATTACK_AIR )
						for i in range(2):
							pPlayer.initUnit( u_Biplane, iX, iY, UnitAITypes.UNITAI_DEFENSE_AIR )
			### ausgabe2 ###
						CyInterface().addMessage(pPlayer.getID(),false,15,CyTranslator().getText("TXT_KEY_FREE_ZEPPELIN_GAMETXT1",(pCity.getName(),iX)),'',0,'Art/Interface/Buttons/Units/zeppelin2.dds',ColorTypes(11),iX,iY,True,True)
						### message: 3 Zeppelins and 2 Biplanes in %s created! ###
					elif ( platzierung == 2 ):
						for i in range(2):
							pPlayer.initUnit( u_Zeppelin, iX, iY, UnitAITypes.UNITAI_ATTACK_AIR )
						for i in range(2):
							pPlayer.initUnit( u_Biplane, iX, iY, UnitAITypes.UNITAI_DEFENSE_AIR )
			### ausgabe3 ###
						CyInterface().addMessage(pPlayer.getID(),false,15,CyTranslator().getText("TXT_KEY_FREE_ZEPPELIN_GAMETXT2",(pCity.getName(),iX)),'',0,'Art/Interface/Buttons/Units/zeppelin2.dds',ColorTypes(11),iX,iY,True,True)
						### message: 2 Zeppelins and 2 Biplanes in %s created! ###
					elif ( platzierung == 3 ):				
						for i in range(2):
							pPlayer.initUnit( u_Zeppelin, iX, iY, UnitAITypes.UNITAI_ATTACK_AIR )
						pPlayer.initUnit( u_Biplane, iX, iY, UnitAITypes.UNITAI_DEFENSE_AIR )
			### ausgabe4 ###
						CyInterface().addMessage(pPlayer.getID(),false,15,CyTranslator().getText("TXT_KEY_FREE_ZEPPELIN_GAMETXT3",(pCity.getName(),iX)),'',0,'Art/Interface/Buttons/Units/zeppelin2.dds',ColorTypes(11),iX,iY,True,True)
						### message: 2 Zeppelins and 1 Biplane in %s created! ###
					elif ( platzierung == 4 ):				
						pPlayer.initUnit( u_Zeppelin, iX, iY, UnitAITypes.UNITAI_ATTACK_AIR )
						pPlayer.initUnit( u_Biplane, iX, iY, UnitAITypes.UNITAI_DEFENSE_AIR )
			### ausgabe5 ###
						CyInterface().addMessage(pPlayer.getID(),false,15,CyTranslator().getText("TXT_KEY_FREE_ZEPPELIN_GAMETXT4",(pCity.getName(),iX)),'',0,'Art/Interface/Buttons/Units/zeppelin2.dds',ColorTypes(11),iX,iY,True,True)
						### message: 1 Zeppelin and 1 Biplane in %s created! ###
					elif ( platzierung == 5 ):				
						pPlayer.initUnit( u_Zeppelin, iX, iY, UnitAITypes.UNITAI_ATTACK_AIR )
			### ausgabe6 ###
						CyInterface().addMessage(pPlayer.getID(),false,15,CyTranslator().getText("TXT_KEY_FREE_ZEPPELIN_GAMETXT5",(pCity.getName(),iX)),'',0,'Art/Interface/Buttons/Units/zeppelin2.dds',ColorTypes(11),iX,iY,True,True)
						### message: 1 Zeppelin in %s created! ###


############################################################
### - Build Musket Manufacture after acquire Gunpowder - ###
############################################################
	### jeha - its a cheat to help the ai ###
		if ( iTechType == (gc.getInfoTypeForString("TECH_GUNPOWDER")) ):
			pPlayer = gc.getPlayer(iPlayer)
			if ( pPlayer.isHuman()==false ):
				b_musket_m = gc.getInfoTypeForString('BUILDING_MUSKET_MANUFAKTUR')
				for iCity in range(pPlayer.getNumCities()):
					pCity = pPlayer.getCity(iCity)
					if ( pCity.isCapital() == true ):
						pCity.setHasRealBuilding(b_musket_m,1)

#####################################
### - PLACE "GIMMICK" RESOURCES - ###
#####################################
		### filter ###
		if ( iTechType == (gc.getInfoTypeForString("TECH_POTTERY")) or iTechType == (gc.getInfoTypeForString("TECH_CALENDAR")) or iTechType == (gc.getInfoTypeForString("TECH_MEDITATION")) or iTechType == (gc.getInfoTypeForString("TECH_BIOLOGY")) ):
			pPlayer = gc.getPlayer(iPlayer)
			if ( pPlayer.isAlive() and (not pPlayer.isBarbarian()) ):

				if ( iTechType == (gc.getInfoTypeForString("TECH_POTTERY")) ):
					# ERAPFE / POTATOES #
					gimmickT = 1
					t_gT = gc.getInfoTypeForString("TECH_POTTERY")
					br_gB = gc.getInfoTypeForString("BONUS_POTATO")
				elif ( iTechType == (gc.getInfoTypeForString("TECH_BIOLOGY")) ):
					# ERAPFE / POTATOES #
					gimmickT = 1
					t_gT = gc.getInfoTypeForString("TECH_BIOLOGY")
					br_gB = gc.getInfoTypeForString("BONUS_POTATO")
				elif ( iTechType == (gc.getInfoTypeForString("TECH_CALENDAR")) ):
					# ZITRONEN / LEMON #
					gimmickT = 2
					t_gT = gc.getInfoTypeForString("TECH_CALENDAR")
					br_gB = gc.getInfoTypeForString("BONUS_LEMON")
				elif ( iTechType == (gc.getInfoTypeForString("TECH_MEDITATION")) ):
					# HANF / CANNABIS #
					gimmickT = 3
					t_gT = gc.getInfoTypeForString("TECH_MEDITATION")
					br_gB = gc.getInfoTypeForString("BONUS_CANNABIS")
				tt_coast = gc.getInfoTypeForString( 'TERRAIN_COAST' )
				tt_ocean = gc.getInfoTypeForString( 'TERRAIN_OCEAN' )
				tt_tundra = gc.getInfoTypeForString( 'TERRAIN_TUNDRA' )
				tt_snow = gc.getInfoTypeForString( 'TERRAIN_SNOW' )
				tt_desert = gc.getInfoTypeForString( 'TERRAIN_DESERT' )
				ft_oasis = gc.getInfoTypeForString('FEATURE_OASIS')
				ft_ice = gc.getInfoTypeForString('FEATURE_ICE')
				platzierung = 0
				nPlayer = 0

			### is he the last one researching this tech? ###
				for iiPlayer in range(gc.getMAX_PLAYERS()):
					ppPlayer = gc.getPlayer(iiPlayer)
					if ( ppPlayer.isAlive() and (not ppPlayer.isBarbarian()) ):
						nPlayer += 1
						if ( gc.getTeam(ppPlayer.getTeam()).isHasTech(t_gT) == true ):
							platzierung += 1

				if ( (platzierung == nPlayer) ):

			### who is the last/last-1 in rank? ###
					for iiPlayer in range(gc.getMAX_PLAYERS()):
						ppPlayer = gc.getPlayer(iiPlayer)
						if ( ppPlayer.isAlive() and (not ppPlayer.isBarbarian()) ):
							ppPID = ppPlayer.getID()
							pp_rank = CyGame().getPlayerRank(ppPID)
							if ( pp_rank == (nPlayer - 1) or pp_rank == (nPlayer - 2)  ):
								nPlot = 0
								lpPlotX = []
								lpPlotY = []
								n2Plot = 0
								l2pPlotX = []
								l2pPlotY = []

			### check capital city plots of last rank player ###
								for iCity in range(ppPlayer.getNumCities()):
									ppCity = ppPlayer.getCity(iCity)
									if ( ppCity.isCapital() == true ):
										iX = ppCity.getX()
										iY = ppCity.getY()
										ppCityName = ppCity.getName()
										for iXLoop in range(iX - 2, iX + 3, 1):
											for iYLoop in range(iY - 2, iY + 3, 1):
												pPlot = CyMap().plot(iXLoop, iYLoop)
									### only this plots ###
												if ( iX == iXLoop and iY == iYLoop ):
													platzierung = platzierung
												else:
													if ( pPlot.isPlayerCityRadius(ppPID)==true ):
														if ( pPlot.getTerrainType()!=tt_coast and pPlot.getTerrainType()!=tt_ocean and pPlot.isPeak()==false ):
															if ( pPlot.getFeatureType()!=ft_oasis and pPlot.getFeatureType()!=ft_ice ):
																if ( pPlot.getBonusType(-1) == gc.getInfoTypeForString('NO_BONUS') ):
																	if ( gimmickT == 3 ):
																		### optimal plots ###
																		lpPlotX.append(iXLoop)
																		lpPlotY.append(iYLoop)
																		nPlot += 1
																	elif ( gimmickT == 2 ):
																		### optimal plots ###
																		if ( pPlot.getTerrainType()!=tt_tundra and pPlot.getTerrainType()!=tt_snow ):
																			lpPlotX.append(iXLoop)
																			lpPlotY.append(iYLoop)
																			nPlot += 1
																		### not so optimal plots ###
																		if ( pPlot.getTerrainType()==tt_tundra or pPlot.getTerrainType()!=tt_snow ):
																			l2pPlotX.append(iXLoop)
																			l2pPlotY.append(iYLoop)
																			n2Plot += 1
																	elif ( gimmickT == 1 ):
																		### optimal plots ###
																		if ( pPlot.getTerrainType()!=tt_desert and pPlot.isHills()==false ):
																			lpPlotX.append(iXLoop)
																			lpPlotY.append(iYLoop)
																			nPlot += 1
																		### not so optimal plots ###
																		if ( pPlot.getTerrainType()==tt_desert or pPlot.isHills()==true ):
																			l2pPlotX.append(iXLoop)
																			l2pPlotY.append(iYLoop)
																			n2Plot += 1

							### if no optimal city radius plost available, place recources on not so optimal plots ###
								if ( nPlot == 0 ):
									if ( n2Plot != 0 ):
										chance = CyGame().getSorenRandNum(n2Plot, "new resource plot")
										iX = l2pPlotX[chance]
										iY = l2pPlotY[chance]
										pPlot = CyMap().plot(iX, iY)
										pPlot.setBonusType(br_gB)
										nPlot += 1
								### if no free city radius plot available, check the city plot ###
									if ( nPlot == 0 ):
										pPlot = CyMap().plot(iX, iY)
										if ( pPlot.getBonusType(-1) == gc.getInfoTypeForString('NO_BONUS') ):
											pPlot.setBonusType(br_gB)
											nPlot += 1

							### if free/optimal city radius plot available, place the new resource at random plot ###
								elif ( nPlot > 0 ):
									chance = CyGame().getSorenRandNum(nPlot, "new resource plot")
									iX = lpPlotX[chance]
									iY = lpPlotY[chance]
									pPlot = CyMap().plot(iX, iY)
									pPlot.setBonusType(br_gB)

			### ausgabe ###
							### if new resource was placed, show message ###
								if ( nPlot > 0 ):
									CyInterface().addMessage(ppPID,True,15,"",'',1,gc.getBonusInfo(br_gB).getButton(),ColorTypes(2), iX, iY,True,True)
									CyInterface().addMessage(ppPID,false,15,CyTranslator().getText("TXT_KEY_GIMMICK_RESOURCES_GAMETXT1",(PyHelpers.PyInfo.BonusInfo(br_gB).getDescription(),ppCityName)),'AS2D_DISCOVERBONUS',0,gc.getBonusInfo(br_gB).getButton(),ColorTypes(2), iX, iY,True,True)
									### message: You have discovered a source of %s near %s! ###

########################################################################################################################################

class adSpecTerra:						
	def onUnitMove(self, argsList):

		#'unit move'
		pPlot,pUnit = argsList

#####################################
### - UNIQUE UNIT UPGRADE (1/2) - ###
#####################################
	### def spec unit upgrade ###
		i_fort = gc.getInfoTypeForString("IMPROVEMENT_FORT")
		u_mArmor = gc.getInfoTypeForString("UNIT_MODERN_ARMOR")
		u_mArmorD = gc.getInfoTypeForString("UNIT_MODERN_ARMOR_DESERT")
		u_mArmorS = gc.getInfoTypeForString("UNIT_MODERN_ARMOR_SNOW")
		u_Arty = gc.getInfoTypeForString("UNIT_ARTILLERY")
		unitfilter = [ u_mArmor, u_mArmorD, u_mArmorS, u_Arty ]

	### filter spec unit upgrade ###
		if pUnit.getUnitType() in unitfilter:

			p_warmth1 = gc.getInfoTypeForString("PROMOTION_WARMTH1")
			p_cold1 = gc.getInfoTypeForString("PROMOTION_COLD1")
			p_freeup = gc.getInfoTypeForString("PROMOTION_FREEUPGRADE")
			m_freeup = 0

		########################################################
		### - Modern Armor upgraded to Modern Armor Desert - ###
		########################################################
			if ( pUnit.getUnitType() == u_mArmor ):
				if ( pUnit.isHasPromotion(p_warmth1)==true ):
			### 25% chance to get a free upgrade promotion (upgrade to Modern Armor Desert) if the Modern Armor moves on desert plot(s) ###
					if ( pUnit.isHasPromotion(p_freeup)==false ):
						if ( pPlot.getTerrainType() == gc.getInfoTypeForString( "TERRAIN_DESERT" ) ):
							chance = CyGame().getSorenRandNum(100, "Random for Modern Armore Desert upgrade")
							if chance >= 75:
								pUnit.setHasPromotion(p_freeup, true)
								m_freeup = 1
			### upgrade Modern Armor with free upgrade promotion to Modern Armore Desert ###
					if ( pUnit.isHasPromotion(p_freeup)==true ):
						if ( pUnit.isHasPromotion(p_cold1)==false ):
							if ( (pPlot.isCity()==true) or (pPlot.getImprovementType()==i_fort) ):
								pPlayer = gc.getPlayer(pUnit.getOwner())
								newUnit = u_mArmorD
								pNewUnit = pPlayer.initUnit( u_mArmorD, pUnit.plot().getX(), pUnit.plot().getY(), UnitAITypes.NO_UNITAI )
        							pNewUnit.convert(pUnit)
								pNewUnit.setHasPromotion(p_freeup, false)
								pNewUnit.finishMoves()
								m_freeup = 2

		########################################################
		### - Modern Armor upgraded to Modern Armor Arctic - ###
		########################################################
			if ( pUnit.getUnitType() == u_mArmor ):
				if ( pUnit.isHasPromotion(p_cold1)==true ):
			### 25% chance to get a free upgrade promotion (upgrade to Modern Armor Arctic) if the Modern Armor moves on snow or tundra plot(s) ###
					if ( pUnit.isHasPromotion(p_freeup)==false ):
						if ( (pPlot.getTerrainType()==gc.getInfoTypeForString( "TERRAIN_SNOW" )) or (pPlot.getTerrainType()==gc.getInfoTypeForString( "TERRAIN_TUNDRA" )) ):
							chance = CyGame().getSorenRandNum(100, "Random for Modern Armore Arctic upgrade")
							if chance >= 75:
								pUnit.setHasPromotion(p_freeup, true)
								m_freeup = 1
			### upgrade Modern Armor with free upgrade promotion to Modern Armore Arctic ###
					if ( pUnit.isHasPromotion(p_freeup)==true ):
						if ( (pPlot.isCity()==true) or (pPlot.getImprovementType()==i_fort) ):
							pPlayer = gc.getPlayer(pUnit.getOwner())
							newUnit = u_mArmorS
							pNewUnit = pPlayer.initUnit( u_mArmorS, pUnit.plot().getX(), pUnit.plot().getY(), UnitAITypes.NO_UNITAI )
        						pNewUnit.convert(pUnit)
							pNewUnit.setHasPromotion(p_freeup, false)
							pNewUnit.finishMoves()
							m_freeup = 2

		#######################################################
		### - Artillery upgraded to a Howitzer (part 2/2) - ###
		#######################################################
			if ( pUnit.getUnitType() == u_Arty ):
				if ( pUnit.isHasPromotion(p_freeup)==true ):
					if ( (pPlot.isCity()==true) or (pPlot.getImprovementType()==i_fort) ):
    						newUnit = gc.getInfoTypeForString("UNIT_MOBILEART")
        					pPlayer = gc.getPlayer(pUnit.getOwner())
						pNewUnit = pPlayer.initUnit( newUnit, pUnit.plot().getX(), pUnit.plot().getY(), UnitAITypes.NO_UNITAI )
        					pNewUnit.convert(pUnit)
						pNewUnit.setHasPromotion(p_freeup, false)
						pNewUnit.finishMoves()
						m_freeup = 2

		###############################################################
		### - Modern Armor upgraded to a Koenigstieger (part 2/2) - ###
		###############################################################
			if ( pUnit.isHasPromotion(p_freeup)==true ):
				if ( pUnit.getUnitType() != u_Arty ):
					if ( (pPlot.isCity()==true) or (pPlot.getImprovementType()==i_fort) ): 
						if ( ( (pUnit.getUnitType()==u_mArmor) and (pUnit.isHasPromotion(p_warmth1)==false) and (pUnit.isHasPromotion(p_cold1)==false) ) or (pUnit.getUnitType()==u_mArmorD) or (pUnit.getUnitType()==u_mArmorS) ):
							### upgrade Modern Armor (desert/arctic) with free upgrade promotion to Koenigstieger ###
							pPlayer = gc.getPlayer(pUnit.getOwner())
							if ( gc.getTeam(pPlayer.getTeam()).isHasTech(gc.getInfoTypeForString("TECH_ARTIFICIAL_INTELLIGENCE")) == true ):
    								newUnit = gc.getInfoTypeForString("UNIT_MODERNARMOR2")
								pNewUnit = pPlayer.initUnit( newUnit, pUnit.plot().getX(), pUnit.plot().getY(), UnitAITypes.NO_UNITAI )
        							pNewUnit.convert(pUnit)
								pNewUnit.setHasPromotion(p_freeup, false)
								pNewUnit.finishMoves()
								m_freeup = 2

		### ausgabe ###
			if (  m_freeup != 0 ):
				cUnit = PyInfo.UnitInfo(pUnit.getUnitType())
				if (  m_freeup == 1 ):
					pPlayer = gc.getPlayer(pUnit.getOwner())
					CyInterface().addMessage(pPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_LEONARDO_WONDER_GAMETXT2",(cUnit.getDescription(),m_freeup)),'',0,'Art/Interface/Buttons/promotions/freeupgrade.dds',ColorTypes(11), pUnit.plot().getX(), pUnit.plot().getY(),True,True)
					### message: Your %s gained a free Upgrade Promotion! ###
				if (  m_freeup == 2 ):
					ccUnit = PyInfo.UnitInfo(pNewUnit.getUnitType())
					CyInterface().addMessage(pPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_LEONARDO_WONDER_GAMETXT1",(cUnit.getDescription(),ccUnit.getDescription())),'AS2D_UNIT_BUILD_TANK',0,gc.getUnitInfo(newUnit).getButton(),ColorTypes(11), pUnit.plot().getX(), pUnit.plot().getY(),True,True)
					### message: Your %s upgraded to a %s! ###

##############################################################################
### - Unit gain a free Upgrade           from Leonardo Wonder (part 2/3) - ###
##############################################################################
		if ( (pPlot.isCity()==true) or (pPlot.getImprovementType()==i_fort) ):
			p_freeup = gc.getInfoTypeForString("PROMOTION_FREEUPGRADE")
			if ( pUnit.isHasPromotion(p_freeup) ):
				pUnit.setMoves(1)
				pPlayer = gc.getPlayer(pUnit.getOwner())
	### check if the unit can upgrade and remember possible upgrades (lUnitCx list) ###
				lUnitCx = []
				upgposs = 0
				for iUnitC in range(gc.getNumUnitInfos()):
					if ( pUnit.canUpgrade( iUnitC, true) == true ):
						lUnitCx.append(iUnitC)
						upgposs += 1
	### if the unit can upgrade,... ###
				if ( upgposs > 0 ):
					iX = pUnit.plot().getX()
					iY = pUnit.plot().getY()
	### ...choose one of the possibilities in the lUnitCx list and upgrade ###
					iRand = CyGame().getSorenRandNum( upgposs, "Random which new Up")
					pnewUp = lUnitCx[iRand]
					pNewUnit = pPlayer.initUnit( pnewUp, iX, iY, UnitAITypes.NO_UNITAI )
					pNewUnit.convert(pUnit)
					pNewUnit.setHasPromotion(p_freeup, false)
		### check if the unit was a musketman with musket promotion - if yes, remove it ###
					if ( pNewUnit.getUnitClassType() != gc.getInfoTypeForString("UNITCLASS_MUSKETMAN") ):
						if ( pNewUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_MUSKETE"))==true ):
							pNewUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_MUSKETE"), false)
					pNewUnit.finishMoves()
	### ausgabe ###
					cUnit = PyInfo.UnitInfo(pUnit.getUnitType())
					ccUnit = PyInfo.UnitInfo(pNewUnit.getUnitType())
					CyInterface().addMessage(pPlayer.getID(),True,15,CyTranslator().getText("TXT_KEY_LEONARDO_WONDER_GAMETXT1",(cUnit.getDescription(),ccUnit.getDescription())),'AS2D_UNIT_BUILD_UNIQUE_UNIT',0,'Art/Interface/Buttons/promotions/freeupgrade.dds',ColorTypes(11),iX,iY,True,True)
					### message: Your %s upgraded to a %s! ###

###############################################################################
### - Remove free Muskete Promotion from all Units expect Musketman (2/2) - ###
###############################################################################
		if ( pUnit.getUnitClassType() != gc.getInfoTypeForString("UNITCLASS_MUSKETMAN") ):
			if ( pUnit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_MUSKETE"))==true ):
				pUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_MUSKETE"), false)

########################################################################################################################################

class adPartisan:

	def onCityAcquired(self, argsList):
		owner,playerType,city,bConquest,bTrade = argsList

#################################
### - create partisan units - ###
#################################

		### number of Partisan units depending on city size (before conquest) and if  ###
		### the loser of the city is stronger or weaker (military power) as the new   ###
		###                          owner of the city.                               ###
		###---------------------------------------------------------------------------###
		###  city size  | Partisan Units if | Partisan Units if   | reduce population ###
		### before conq.| loser weaker conq.| loser stronger conq.|                   ###
		###-------------+-------------------+---------------------+-------------------###
		###    01-07    |       1 - 2       |       0 - 1         |         0         ###
		###    08-14    |       2 - 3       |       1 - 2         |  - num partisans  ###
		###    15-21    |       3 - 5       |       1 - 3         |  - num partisans  ###
		###    22-28    |       4 - 6       |       2 - 4         |  - num partisans  ###
		###    29-35    |       5 - 8       |       2 - 5         |  - num partisans  ###
		###    36-42    |       6 - 9       |       3 - 6         |  - num partisans  ###
		###     ...     |        ...        |        ...          |  - num partisans  ###
		###-------------+-------------------+---------------------+-------------------###
		###             |  +3 units with    |  +3 units with      |                   ###
		###             |  NATIONHOOD civic |  NATIONHOOD civic   |                   ###


		###      new created Partisan units will get more and more promotions with higher       ###
		###      tech level and also get special promotions dependig on the "start" plot        ###
		###-------------------------------------------------------------------------------------###
		###     technology      |     plot types      |      promotions      |      chance      ###
		###---------------------+---------------------+----------------------+------------------###
		###      rifling        |          you need rifling tech to get Partisan units          ###
		###    assembly line    |          -          |       + drill        |       100%       ###
		###    industrialism    |          -          |       + drill        |       100%       ###
		###      rocketry       |          -          |       + drill        |       100%       ###
		###      plastics       |          -          |       + drill        |       100%       ###
		###      computers      |          -          |       + drill        |       100%       ###
		###     combustion      |          -          |     + flanking I     |       100%       ###
		###      refining       |          -          |     + flanking II    |       100%       ###
		###       radio         |          -          |     + flanking III   |        50%       ###
		###      fascism        |          -          |       + combat       |        50%       ###
		###         -           |   forest / jungle   |     + woodsman I     |       100%       ###
		###    assembly line    |   forest / jungle   |     + woodsman II    |        75%       ###
		###    industrialism    |   forest / jungle   |     + woodsman III   |        50%       ###
		###         -           |        hill         |     + guerilla I     |       100%       ###
		###    assembly line    |        hill         |     + guerilla II    |        75%       ###
		###    industrialism    |        hill         |     + guerilla III   |        50%       ###
		###         -           |       desert        |  + desert combat I   |       100%       ###
		###    assembly line    |       desert        |  + desert combat II  |        75%       ###
		###         -           |    tundra / snow    |  + arctic combat I   |       100%       ###
		###    assembly line    |    tundra / snow    |  + arctic combat II  |        75%       ###

		if bConquest:
			loserPlayer = gc.getPlayer(owner)
			loserPlayerTeam = loserPlayer.getTeam()
	### partisans only available with rifling tech ###
			if ( gc.getTeam(loserPlayerTeam).isHasTech(gc.getInfoTypeForString("TECH_RIFLING")) == true ):
	### dont place partisan units if you capture your city back ###
				if ( city.isOccupation()==true ):
	### dont show partisan message if loserPlayer is already death ###
					if ( loserPlayer.isAlive()==true ):

						u_partisan = gc.getInfoTypeForString( 'UNIT_PARTISAN' )		
						loserTeam = gc.getTeam(owner)
						loserPlayerID = loserPlayer.getID()
						lPnCities = loserPlayer.getNumCities()
						conqTeam = gc.getTeam(city.getOwner())
						conqPlayer = gc.getPlayer(city.getOwner())
						conqPlayerID = conqPlayer.getID()
						iX = city.getX()
						iY = city.getY()
						cityName = city.getName()
						tt_noterrain = gc.getInfoTypeForString( 'NO_TERRAIN' )
						tt_coast = gc.getInfoTypeForString( 'TERRAIN_COAST' )
						tt_ocean = gc.getInfoTypeForString( 'TERRAIN_OCEAN' )
						tt_desert = gc.getInfoTypeForString( 'TERRAIN_DESERT' )
						tt_tundra = gc.getInfoTypeForString( 'TERRAIN_TUNDRA' )
						tt_snow = gc.getInfoTypeForString( 'TERRAIN_SNOW' )
						ft_ice = gc.getInfoTypeForString('FEATURE_ICE')
						ft_forest = gc.getInfoTypeForString('FEATURE_FOREST')
						ft_jungle = gc.getInfoTypeForString( 'FEATURE_JUNGLE' )
						it_fort = gc.getInfoTypeForString("IMPROVEMENT_FORT") 
						t_rocketry = gc.getInfoTypeForString("TECH_ROCKETRY")
						t_plastics = gc.getInfoTypeForString("TECH_PLASTICS")
						t_assemblyline = gc.getInfoTypeForString("TECH_ASSEMBLY_LINE")
						t_industrialism = gc.getInfoTypeForString("TECH_INDUSTRIALISM")
						t_computers = gc.getInfoTypeForString("TECH_COMPUTERS")
						t_combustion = gc.getInfoTypeForString("TECH_COMBUSTION")
						t_refining = gc.getInfoTypeForString("TECH_REFINING")
						t_radio = gc.getInfoTypeForString("TECH_RADIO")
						t_fascism = gc.getInfoTypeForString("TECH_FASCISM")
						p_drill1 = gc.getInfoTypeForString( "PROMOTION_DRILL1" )
						p_drill2 = gc.getInfoTypeForString( "PROMOTION_DRILL2" )
						p_drill3 = gc.getInfoTypeForString( "PROMOTION_DRILL3" )
						p_drill4 = gc.getInfoTypeForString( "PROMOTION_DRILL4" )
						p_drill5 = gc.getInfoTypeForString( "PROMOTION_DRILL5" )
						p_flanking1 = gc.getInfoTypeForString( 'PROMOTION_FLANKING1' )
						p_flanking2 = gc.getInfoTypeForString( 'PROMOTION_FLANKING2' )
						p_flanking3 = gc.getInfoTypeForString( 'PROMOTION_FLANKING3' )
						p_combat1 = gc.getInfoTypeForString("PROMOTION_COMBAT1")
						p_combat2 = gc.getInfoTypeForString("PROMOTION_COMBAT2")
						p_woodsman1 = gc.getInfoTypeForString("PROMOTION_WOODSMAN1")
						p_guerilla1 = gc.getInfoTypeForString("PROMOTION_GUERILLA1")
						p_warmth1 = gc.getInfoTypeForString("PROMOTION_WARMTH1")
						p_cold1 = gc.getInfoTypeForString("PROMOTION_COLD1")
						i_inner_plot = -1
						l_inner_plot = [0,0,0,0,0,0,1,1,1,0,0,1,1,1,0,0,1,1,1,0,0,0,0,0,0]
						lpPlots = []
						drilltech = 0
						count_Partisan = 0
						damage = 0

	### more/fewer partisans if the loser is weaker/stronger (power) - also depending on city size ###
						citysize = city.getPopulation()
						nPartisan = (citysize / 7) + 1
	### +3 partisans with nationhood civic ###
						if ( citysize >= 6 ):
							if ( loserPlayer.getCivics(gc.getInfoTypeForString('CIVICOPTION_LEGAL'))==gc.getInfoTypeForString('CIVIC_NATIONHOOD') ):
								nPartisan += 3

			### random number (between 1 and 3*) depending on city size (begin) ###
						rel_ativ = 1
						if ( citysize > 14 ):
							rel_ativ = 2
						if ( citysize > 28 ):
							rel_ativ = 3
						iRand = CyGame().getSorenRandNum( rel_ativ, "Random which pPlot for Partisan")
						rel_ativ = iRand + 1
			### random number (between 1 and 3*) depending on city size (end) ###

			### add/take away the random number from the nPartisan (depending on power) ###
						if ( loserPlayer.getPower() > conqPlayer.getPower() ):
							iRand = CyGame().getSorenRandNum( 10, "Random which pPlot for Partisan")
							### 40% chance for more units ###
							if ( iRand < 6 ):
								nPartisan -= rel_ativ
						elif ( loserPlayer.getPower() < conqPlayer.getPower() ):
							iRand = CyGame().getSorenRandNum( 10, "Random which pPlot for Partisan")
							### 40% chance for more units ###
							if ( iRand >= 6 ):
								nPartisan += rel_ativ

	### check all city radius plots ###
						for iXLoop in range(iX - 2, iX + 3, 1):
							for iYLoop in range(iY - 2, iY + 3, 1):
								i_inner_plot += 1
								pPlot = CyMap().plot(iXLoop, iYLoop)
								if ( pPlot.getTerrainType()!=tt_noterrain and pPlot.getTerrainType()!=tt_coast and pPlot.getTerrainType()!=tt_ocean and pPlot.getFeatureType()!=ft_ice and pPlot.isPeak()==false ):
									if ( pPlot.isCity()==false ):
										if ( pPlot.isVisibleEnemyUnit(loserPlayerID)==false ):
											lpPlots.append(pPlot)
			### doubles the chance to set the partisan in the inner city radius ###
											if ( l_inner_plot[i_inner_plot] == 1 ):
												lpPlots.append(pPlot)
					### increase the chance to set the partisan in the inner city radius with certain extras ###
												if ( pPlot.getFeatureType()==ft_forest or pPlot.getFeatureType()==ft_jungle or pPlot.isHills()==true or pPlot.getImprovementType()==it_fort ):
													for i in range(4):
														lpPlots.append(pPlot)
	### set partisan(s) ###
						if ( len(lpPlots) > 0 ):
							while ( nPartisan > 0 ):
								nPartisan -= 1
								count_Partisan += 1
								iRand = CyGame().getSorenRandNum( len(lpPlots), "Random which pPlot for Partisan")
								pPlot = lpPlots[iRand]
								iiX = pPlot.getX()
								iiY = pPlot.getY()
								pNewUnit = loserPlayer.initUnit( u_partisan, iiX, iiY, UnitAITypes.UNITAI_ATTACK_CITY )
		### set aditional promotions ###
				### tech lvl depending promotions ###
						### DRILL promotions ###
								if ( gc.getTeam(loserPlayerTeam).isHasTech(t_assemblyline) == true ):
									drilltech += 1
								if ( gc.getTeam(loserPlayerTeam).isHasTech(t_industrialism) == true ):
									drilltech += 1
								if ( gc.getTeam(loserPlayerTeam).isHasTech(t_rocketry) == true ):
									drilltech += 1
								if ( gc.getTeam(loserPlayerTeam).isHasTech(t_plastics) == true ):
									drilltech += 1
								if ( gc.getTeam(loserPlayerTeam).isHasTech(t_computers) == true ):
									drilltech += 1
								while ( drilltech > 0 ):
									drilltech -= 1
									if ( pNewUnit.isHasPromotion(p_drill1)==false ):
										pNewUnit.setHasPromotion(p_drill1, true)
									elif ( pNewUnit.isHasPromotion(p_drill2)==false ):
										pNewUnit.setHasPromotion(p_drill2, true)
									elif ( pNewUnit.isHasPromotion(p_drill3)==false ):
										pNewUnit.setHasPromotion(p_drill3, true)
									elif ( pNewUnit.isHasPromotion(p_drill4)==false ):
										pNewUnit.setHasPromotion(p_drill4, true)
									elif ( pNewUnit.isHasPromotion(p_drill5)==false ):
										pNewUnit.setHasPromotion(p_drill5, true)
						### FLANKING promotions ###
								if ( gc.getTeam(loserPlayerTeam).isHasTech(t_combustion) == true ):
									pNewUnit.setHasPromotion(p_flanking1, true)
								if ( gc.getTeam(loserPlayerTeam).isHasTech(t_refining) == true ):
									pNewUnit.setHasPromotion(p_flanking2, true)
								if ( gc.getTeam(loserPlayerTeam).isHasTech(t_radio) == true ):
									chance = CyGame().getSorenRandNum( 2, "Random Flanking III")
									if ( chance == 0 ):
										pNewUnit.setHasPromotion(p_flanking3, true)
						### COMBAT promotion ###
								if ( gc.getTeam(loserPlayerTeam).isHasTech(t_fascism) == true ):
									chance = CyGame().getSorenRandNum( 2, "Random Combat1/2")
									if ( chance == 0 ):
										if ( pNewUnit.isHasPromotion(p_combat1)==false ):
											pNewUnit.setHasPromotion(p_combat1, true)
										elif ( pNewUnit.isHasPromotion(p_combat1)==true ):
											pNewUnit.setHasPromotion(p_combat2, true)
				### plot type depending promotions ###
						### WOODSMAN promotion ###
								if ( pPlot.getFeatureType()==ft_forest or pPlot.getFeatureType()==ft_jungle ):
									pNewUnit.setHasPromotion(p_woodsman1, true)
									chance = CyGame().getSorenRandNum( 4, "Random Woodsman2")
									if ( chance >= 1 ):
										if ( gc.getTeam(loserPlayerTeam).isHasTech(t_assemblyline) == true ):
											pNewUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_WOODSMAN2"), true)
											chance = CyGame().getSorenRandNum( 4, "Random Woodsman3")
											if ( chance >= 1 ):
												if ( gc.getTeam(loserPlayerTeam).isHasTech(t_industrialism) == true ):
													pNewUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_WOODSMAN3"), true)
						### DESERT COMBAT promotion ###
								if ( pPlot.getTerrainType()==tt_desert ):
									pNewUnit.setHasPromotion(p_warmth1, true)
									chance = CyGame().getSorenRandNum( 4, "Random DesertCombat2")
									if ( chance >= 1 ):
										if ( gc.getTeam(loserPlayerTeam).isHasTech(t_assemblyline) == true ):
											pNewUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_WARMTH2"), true)
						### ARCTIC COMBAT promotion ###
								if ( pPlot.getTerrainType()==tt_tundra or pPlot.getTerrainType()==tt_snow ):
									pNewUnit.setHasPromotion(p_cold1, true)
									chance = CyGame().getSorenRandNum( 4, "Random ArcticCombat2")
									if ( chance >= 1 ):
										if ( gc.getTeam(loserPlayerTeam).isHasTech(t_assemblyline) == true ):
											pNewUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_COLD2"), true)
						### GUERILLA promotion ###
								if ( pPlot.isHills()==true ):
									pNewUnit.setHasPromotion(p_guerilla1, true)
									chance = CyGame().getSorenRandNum( 4, "Random Guerilla2")
									if ( chance >= 1 ):
										if ( gc.getTeam(loserPlayerTeam).isHasTech(t_assemblyline) == true ):
											pNewUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_GUERILLA2"), true)
											chance = CyGame().getSorenRandNum( 4, "Random Guerilla3")
											if ( chance >= 1 ):
												if ( gc.getTeam(loserPlayerTeam).isHasTech(t_industrialism) == true ):
													pNewUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_GUERILLA3"), true)

		### set random damage to random enemy units near the partisan unit ###
							### remember all EnemyUnits near the partisan ###
								lEnemyUnits = []
								for iiXLoop in range(iiX - 1, iiX + 2, 1):
									for iiYLoop in range(iiY - 1, iiY + 2, 1):
										ppPlot = CyMap().plot(iiXLoop, iiYLoop)
										if ( ppPlot.isVisibleEnemyUnit(loserPlayerID)==true ):
											for i in range(ppPlot.getNumUnits()):
												if ( ppPlot.isVisibleEnemyUnit(loserPlayerID)==true ):
													ppUnit = ppPlot.getUnit(i)
													lEnemyUnits.append(ppUnit)
								if ( len(lEnemyUnits) > 0 ):
							### random number between 1 and 5 (but not more than EnemyUnits near the partisan unit) ###
									n_EnemyUnits = len(lEnemyUnits)
									if n_EnemyUnits >= 5:
										n_EnemyUnits = 5
									n_EnemyUnits = CyGame().getSorenRandNum( n_EnemyUnits, "Random for how many eunits will suffer damage") + 1
							### choose which EnemyUnit will suffer damage from partisan unit ###
									while ( n_EnemyUnits > 0 ):
										n_EnemyUnits -= 1
										iRand = CyGame().getSorenRandNum( len(lEnemyUnits), "Random which eunit will suffer damage")
										ppUnit = lEnemyUnits[iRand]
									### random for how many damage the eunit will suffer from the partisan attack (15 - 30) ###
										iRand = CyGame().getSorenRandNum( 16, "rand damage") + 15
									### check to not kill the eunit ###
										if ( (ppUnit.getDamage() + iRand) >= 99 ):
											if ( ppUnit.getDamage() <= 98 ):
												iRand = (iRand - ((ppUnit.getDamage() + iRand) - 100))
											else:
												iRand = 0
											ppUnit.setDamage(99, 0)
										else:
											ppUnit.changeDamage(iRand, 0)
										damage = damage + (ppUnit.baseCombatStr() * (iRand * 0.01))
	### ausgabe ###
										i_iX = ppUnit.getX()
										i_iY = ppUnit.getY()
										CyInterface().addMessage(loserPlayerID,True,5,'','',1,'Art/Interface/Buttons/actions/destroy.dds',ColorTypes(11), i_iX, i_iY, True,True)
										CyInterface().addMessage(conqPlayerID,True,5,'','',1,'Art/Interface/Buttons/actions/destroy.dds',ColorTypes(7), i_iX, i_iY, True,True)
								if ( lPnCities > 0 ):
									CyInterface().addMessage(loserPlayerID,True,25,'','',1,'Art/Interface/Buttons/Units/marine.dds',ColorTypes(11), iiX, iiY, True,True)
									CyInterface().addMessage(conqPlayerID,True,25,'','',1,'Art/Interface/Buttons/Units/marine.dds',ColorTypes(7), iiX, iiY, True,True)
							if ( lPnCities > 0 ):
								CyInterface().addMessage(loserPlayerID,true,15,' Our Brave People near %s will Fight against the Enemy! They already caused a total of %d Damage to the Evil Enemy Force. ' %(cityName,damage),'',0,'Art/Interface/Buttons/civics/despotism.dds',ColorTypes(44), iX, iY, True,True)
								CyInterface().addMessage(conqPlayerID,true,15,' Partisans and Terrorists near %s Fight against our Brave Army! They already caused a total of %d Damage to our Glorious Force. ' %(cityName,damage),'',0,'Art/Interface/Buttons/civics/despotism.dds',ColorTypes(7), iX, iY, True,True)
	### reduce population ###
							if ( lPnCities > 0 ):
								if ( citysize > 8 ):
									city.changePopulation(-count_Partisan)